'Curved surfaces example by Agravein
'Agravein@yandex.ru

'$INCLUDE: 'cse.bi'

gsinit
RANDOMIZE TIMER

DIM SHARED mgn AS SINGLE, maxhei AS SINGLE, st AS SINGLE
DIM SHARED XRes, YRes, xs, ys, gh, rad, xc, yc, snshot
DIM SHARED water, spd, posit, waterlev AS SINGLE, sandlev  AS SINGLE
DIM SHARED e00 AS SINGLE, e01 AS SINGLE, e10 AS SINGLE
DIM SHARED e11 AS SINGLE, ez AS SINGLE, grasshei AS SINGLE

XRes = 640: YRes = 480: snshot = 0
spd = 50: xs = 20: ys = 20

mgn = 50: maxhei = 2: st = .04: grasshei = .3: water = 3
e00 = 1: e01 = .5: e10 = -1: e11 = .5: ez = 1
waterlev = .8: sandlev = 1

readcomm

xc = XRes / 2 - (e00 * xs + e10 * ys) * mgn / 2
yc = YRes / 2 - (e01 * xs + e11 * ys - ez * maxhei / 2) * mgn / 2
R! = ez * maxhei
r1! = SQR(e00 * e00 + (R! + e01) ^ 2)
r2! = SQR(e10 * e10 + (R! + e11) ^ 2)
IF r2! > r1! THEN R! = r2! ELSE R! = r1!
rad = CINT(st * mgn * R! / 2) + 1
gh = SQR(e00 * e00 + e11 * e11) * mgn * grasshei * ez

DIM SHARED z(xs, ys) AS SINGLE
DIM SHARED kx(xs, ys) AS SINGLE

SetScreenMode XRes, YRes, 8

Future.CLS 0

FOR a = 0 TO 63
 changePAL a, 0, a, 0
 changePAL a + 64, a, a, 0
 changePAL a + 128, 0, ABS(a + (a > 31) * 127), 63
NEXT a

FOR X = 0 TO xs
 FOR Y = 0 TO ys
  z(X, Y) = RND * maxhei
  'coords x * 1, y * 1, 0, x1, y1
  'coords x + 1, y * 1, 0, x2, y2
  'coords x * 1, y + 1, 0, x3, y3
  'future.line x1, y1, x2, y2, 63, -1
  'future.line x1, y1, x3, y3, 63, -1
NEXT Y, X

FOR X = 1 TO xs - 1
 FOR Y = 1 TO ys - 1
  kx(X, Y) = (z(X + 1, Y) - z(X - 1, Y)) / 2
NEXT Y, X
 
FOR my = 0 TO ys - 1
 FOR mx = 0 TO xs - 1
  IF INKEY$ <> "" THEN exiting
  a$ = LTRIM$(STR$(INT((mx + my * xs) / xs / ys * 100) + 1)) + "% completed"
  X1 = XRes - LEN(a$) * 8 - 1: Y1 = YRes - 17
  Future.BOX X1 - 1, Y1 - 1, XRes - 1, YRes - 1, 127
  Future.PRINT X1, Y1, a$, 63, 0
  G = 0
  FOR dx = 0 TO 1
   FOR dy = 0 TO 1
    z0! = z(mx + dx, my + dx)
    IF z0! < waterlev THEN z0! = waterlev
    z1! = z(mx + dy, my + 1 - dy)
    IF z1! < waterlev THEN z1! = waterlev
    coords mx + dx, my + dx, z0!, X1, Y1
    coords mx + dy, my + 1 - dy, z1!, x2, y2
    dg = 0
    IF (X1 < 0 AND x2 < 0) OR (X1 > XRes AND x2 > XRes) THEN dg = 1
    IF (Y1 < 0 AND y2 < 0) OR (Y1 > YRes AND y2 > YRes) THEN dg = 1
    G = G + dg
  NEXT dy, dx
  mapkoeff a0!, b0!, C0!, d0!, mx, my
  mapkoeff a1!, b1!, C1!, d1!, mx, my + 1
  'future.box mx * 5, my * 5, mx * 5 + 4, my * 5 + 4, g * 15
  IF G < 4 THEN
   FOR X! = 0 TO 1 STEP st

    bpt X!, a0!, b0!, C0!, d0!, z0!, ky0!
    bpt X!, a1!, b1!, C1!, d1!, z1!, ky1!
    koeff z0!, ky0!, z1!, ky1!, a!, B!, C!, d!
    FOR Y! = 0 TO 1 STEP st
     bpt Y!, a!, B!, C!, d!, z!, k!
     coords X! + mx, Y! + my, z!, xx, yy
     cc = INT(31 - 10 * k!)
     
     SELECT CASE z!
      CASE IS <= waterlev
       cc = (INT((z! + 1) * 64 * water) MOD 64) + 128
       coords X! + mx, Y! + my, waterlev, xx, yy
       IF rad <= 1 THEN
        Future.PSET xx, yy, cc
       ELSE
        Future.FILLCIRCLE xx, yy, rad, cc
       END IF
      CASE waterlev TO sandlev
       cc = cc + 64 - INT(RND * 3)
       IF rad <= 1 THEN
        Future.PSET xx, yy, cc
       ELSE
        Future.FILLCIRCLE xx, yy, rad, cc
       END IF
      CASE IS > sandlev
       cc = cc + INT(RND * 5)
       IF rad > 1 THEN Future.FILLCIRCLE xx, yy, rad, cc
       xv = CINT(INT(RND * gh / 2) - gh / 4)
       Future.LINE xx, yy, xx + xv, yy - INT(RND * gh), cc, -1
     END SELECT
    NEXT Y!
   NEXT X!
  END IF

 NEXT mx
NEXT my

IF snshot THEN Future.SNAPSHOT "cse.bmp"

ResetCounter
SetTIMERspeed spd
StartTIMER
DO
 t = (ReadCounter&) MOD 64
 FOR a = 0 TO 63
  B = (a + 64 - t) MOD 64
  changePAL a + 128, 0, ABS(B + (B > 31) * 127), 63
 NEXT a
 IF INKEY$ <> "" THEN exiting
LOOP

SUB bpt (X!, a!, B!, C!, d!, z!, k!)
xv! = X! * X!
z! = a! * X! * xv! + B! * xv! + C! * X! + d!
k! = ATN(3 * a! * xv! + 2 * B! * X! + C!)
END SUB

SUB coords (X!, Y!, z!, xx, yy)
xx = xc + (X! * e00 + Y! * e10) * mgn
yy = yc + (X! * e01 + Y! * e11 - z! * ez) * mgn
END SUB

SUB exiting
ReSetScreen
PRINT "Curved surfaces example by Agravein (Agravein@yandex.ru)"
PRINT "Using Future.Library v3.50 by Jorden Chamid and Michael Rye Sorensen"
PRINT
PRINT "Usage: cse [variable+value] [variable+value] ..."
PRINT "Example: cse EAA1 EAB0 EBA0 EBB1 EZ0 GH0 W1 SPD2"
PRINT
PRINT "Variables list (with value by ignoration in brackets):"
PRINT " XRES(640),YRES(480) - SVGA screen resolution in pixels"
PRINT " XDIM(20),YDIM(20) - Dimensions of landscape array"
PRINT " ST(0.04) - Drawing step (smaller step provides better perfomance)"
PRINT " EAA(1), EAB(0.5), EBA(-1), EBB(0.5), EZ(1)"
PRINT "  is the coordinates of the of the new                  (0,0,EZ)"
PRINT "  coordinate system base reperes (see the picture ->)      z|"
PRINT " MGN(50) - Magnification level                              |"
PRINT " MH(2) - Maximum Z-height                                   |"
PRINT " SL(1), WL(0.8) - Sand Z-level, Water Z-level              / \"
PRINT " W(3) - Water colour changement rate                    y/     \x"
PRINT " SPD(50) - Water colour changement speed      (EBA,EBB,0)        (EAA,EAB,0)"
PRINT " GH(0.3) - Grass height (depending on square size)"
PRINT " SN - Save screen shot to cse.bmp"
END
END SUB

FUNCTION getint
getint = INT(getsng)
END FUNCTION

FUNCTION getsng!
p = 0: v$ = ""
DO
 a$ = MID$(COMMAND$, posit, 1)
 aa = ASC(a$)
 IF (aa >= 48 AND aa <= 57) OR aa = 46 OR aa = 45 THEN i = 0 ELSE i = 1
 IF p + i = 0 THEN p = 1
 IF p * i = 1 THEN EXIT DO
 IF p = 1 THEN v$ = v$ + a$
 posit = posit + 1
 IF posit > LEN(COMMAND$) THEN EXIT DO
LOOP
getsng! = VAL(v$)
END FUNCTION

SUB koeff (z0!, k0!, z1!, k1!, a!, B!, C!, d!)
a! = k0! + 2 * z0! + k1! - 2 * z1!
B! = z1! - a! - z0! - k0!
C! = k0!
d! = z0!
END SUB

SUB mapkoeff (a!, B!, C!, d!, X, Y)
koeff z(X, Y), kx(X, Y), z(X + 1, Y), kx(X + 1, Y), a!, B!, C!, d!
END SUB

SUB readcomm
posit = 1
C$ = COMMAND$ + " "
IF C$ = "" THEN EXIT SUB
DO
 id$ = ""
 DO
  a$ = UCASE$(MID$(C$, posit, 1))
  aa = ASC(a$)
  posit = posit + 1
  IF posit > LEN(C$) THEN EXIT SUB
  IF aa >= 65 AND aa <= 122 THEN
   id$ = id$ + a$
  ELSE
   IF id$ <> "" THEN posit = posit - 1
   EXIT DO
  END IF
 LOOP

 SELECT CASE id$
  CASE "XRES": XRes = getint
  CASE "YRES": YRes = getint
  CASE "XDIM": xs = getint
  CASE "YDIM": ys = getint
  CASE "EAA": e00 = getsng
  CASE "EAB": e01 = getsng
  CASE "EBA": e10 = getsng
  CASE "EBB": e11 = getsng
  CASE "EZ": ez = getsng
  CASE "MH": maxhei = getsng
  CASE "MGN": mgn = getsng
  CASE "ST": st = getsng
  CASE "GH": grasshei = getsng
  CASE "SL": sandlev = getsng
  CASE "W": water = getsng
  CASE "WL": waterlev = getsng
  CASE "SPD": spd = getint
  CASE "SN": snshot = 1
 END SELECT
LOOP UNTIL posit > LEN(COMMAND$)

END SUB

